/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMLabel.hh,v $
// $Revision: 1.10 $
// $State: Exp $
// $Author: grlcr $
// $Date: 89/12/13 08:27:11 $
// $Locker:  $
//
// $Log:	XMLabel.hh,v $
Revision 1.10  89/12/13  08:27:11  grlcr
*** empty log message ***

Revision 1.9  89/12/12  14:05:46  grlcr
*** empty log message ***

Revision 1.8  89/12/07  15:27:08  kseethar
added XMString, KS

Revision 1.7  89/11/29  13:51:20  grlcr
*** empty log message ***

Revision 1.6  89/11/27  11:48:13  grlcr
1st pass

Revision 1.5  89/11/07  13:39:12  grlcr
*** empty log message ***

Revision 1.4  89/11/06  09:36:32  grlcr
Changed Core ptrs to Object

Revision 1.3  89/11/03  18:19:28  grlcr
minor reworking

Revision 1.2  89/11/03  10:55:52  motifplb
*** empty log message ***

Revision 1.1  89/11/02  12:23:40  motifplb
Initial revision

// ***** Created Oct 11, 1989 by Krishnan *****
// ***** dummy constructor added nov 1 by KS *****
// ***** grlcr: minor changes, Nov 3 *****
// ***** grlcr: change Core ptrs to Object, Nov 6 *****
//-----------------------------------------------------------------------------
*/

#ifndef XMLabel_hh
#define XMLabel_hh

#include "XMPrimitive.hh"
#include <Xm/Label.h>

class XMLabel : public XMPrimitive {
 private :
     // ****CONSTRUCTORS**** 
     XMLabel ();

 public :
     // ****CONSTRUCTORS**** 
     XMLabel (XMObject*, String,Boolean managed=True);
     XMLabel (XMObject*, String, XMString*,Boolean managed=True);
     XMLabel (XMObject *parent, String name,
		     Position x,
		     Position y,
//		     char* font_list = NULL,
		     XMFontList* font_list,
//		     Dimension width = 0,
//		     Dimension height = 0,
//		     u_char alignment = XmALIGNMENT_CENTER,
//		     short margin_height = 2,
//		     short margin_width  = 2,
		     Boolean managed = True
		     );


     // ****DESTRUCTOR****
     ~XMLabel ();

     // ****METHODS TO SET THE Label RESOURCES****
     void set_accelerator              (String);
     void set_acceleratorText          (XMString*);
     void set_alignment                (u_char);
     void set_fontList                 (XMFontList*);
     void set_labelInsensitivePixmap   (Pixmap);
     void set_labelPixmap              (Pixmap);
     void set_labelString              (XMString*);
     void set_labelType                (u_char);
     void set_marginBottom             (short);
     void set_marginHeight             (short);
     void set_marginLeft               (short);
     void set_marginRight              (short);
     void set_marginTop                (short);
     void set_marginWidth              (short);
     void set_mnemonic                 (char);
     void set_recomputeSize            (Boolean);
     void set_stringDirection          (XmStringDirection);

     // ****METHODS TO GET THE Label RESOURCES****
     void get_accelerator            (String*);
     void get_acceleratorText        (XMString*);
     void get_alignment              (u_char*);
     void get_fontList               (XMFontList*);
     void get_labelInsensitivePixmap (Pixmap*);
     void get_labelPixmap            (Pixmap*);
     void get_labelString            (XMString*);
     void get_labelType              (u_char*);
     void get_marginBottom           (short*);
     void get_marginHeight           (short*);
     void get_marginLeft             (short*);
     void get_marginRight            (short*);
     void get_marginTop              (short*);
     void get_marginWidth            (short*);
     void get_mnemonic               (char*);
     void get_recomputeSize          (Boolean*);
     void get_stringDirection        (XmStringDirection*);
};

#endif     // XMLabel_hh

// dont add stuff after this endif

