/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMList.hh,v $
// $Revision: 1.6 $
// $State: Exp $
// $Author: grlcr $
// $Date: 89/12/08 15:25:38 $
// $Locker:  $
//
// $Log:	XMList.hh,v $
Revision 1.6  89/12/08  15:25:38  grlcr
*** empty log message ***

Revision 1.5  89/11/27  15:45:24  bmontagu
test

Revision 1.4  89/11/27  11:54:25  grlcr
1st pass

Revision 1.3  89/11/07  11:13:58  grlcr
*** empty log message ***

Revision 1.2  89/11/03  10:57:56  motifplb
*** empty log message ***

Revision 1.1  89/11/02  12:25:25  motifplb
Initial revision

// ***** Created Oct 11, 1989 by BRM *****
// ***** grlcr : add get routines and remove some set routines *****
//-----------------------------------------------------------------------------
*/

#ifndef XMList_hh
#define XMList_hh

#include "XMPrimitive.hh"
#include <Xm/List.h>

class XMList : public XMPrimitive {
 protected :
     // ****CONSTRUCTORS**** 
     XMList ();

 public :
     // ****CONSTRUCTORS**** 
     XMList (XMObject*, String,Boolean managed=True);

     // ****DESTRUCTOR****
     ~XMList ();

     // ****METHODS TO SET THE List RESOURCES****
     void set_automaticSelection              (Boolean);
     void set_doubleClickInterval             (int);
     void set_fontList                        (XMFontList*);
     void set_itemCount                       (int);
     void set_items                           (XmStringTable);
     void set_listMarginHeight                (Dimension);
     void set_listMarginWidth                 (Dimension);
     void set_listSpacing                     (short);
     void set_selectedItemCount               (int);
     void set_selectedItems                   (XmStringTable);
     void set_selectionPolicy                 (u_char);
     void set_stringDirection                 (XmStringDirection);
     void set_visibleItemCount                (int);
     void set_entry_browseSelectionCallback   (XtCallbackProc, caddr_t);
     void set_entry_defaultActionCallback     (XtCallbackProc, caddr_t);
     void set_entry_extendedSelectionCallback (XtCallbackProc, caddr_t);
     void set_entry_multipleSelectionCallback (XtCallbackProc, caddr_t);
     void set_entry_singleSelectionCallback   (XtCallbackProc, caddr_t);

     // ****METHODS TO GET THE List RESOURCES****
     void get_automaticSelection      (Boolean*);
     void get_doubleClickInterval     (int*);
     void get_fontList                (XMFontList*);
     void get_itemCount               (int*);
     void get_items                   (XmStringTable*);
     void get_listMarginHeight        (Dimension*);
     void get_listMarginWidth         (Dimension*);
     void get_listSpacing             (short*);
     void get_selectedItemCount       (int*);
     void get_selectedItems           (XmStringTable*);
     void get_selectionPolicy         (u_char*);
     void get_stringDirection         (XmStringDirection*);
     void get_visibleItemCount        (int*);

     // ****COVER FUNCTION METHODS**** 
     void    AddItem                  (XMString*, int);      
     void    AddItemUnselected        (XMString*, int);      
     void    DeleteItem               (XMString*);           
     void    DeletePos                (int);                
     void    DeselectAllItems         ();           
     void    DeselectItem             (XMString*);           
     void    DeselectPos              (int);                
     Boolean ItemExists               (XMString*);           
     void    SelectItem               (XMString*, Boolean);
     void    SelectPos                (int, Boolean);       
     void    SetBottomItem            (XMString*);
     void    SetBottomPos             (int);                
     void    SetHorizPos              (int);                
     void    SetItem                  (XMString*);           
     void    SetPos                   (int);                
};

#endif     // XMList_hh

// dont add stuff after this endif
