/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMScrolledW.hh,v $
// $Revision: 1.4 $
// $State: Exp $
// $Author: grlcr $
// $Date: 89/12/08 15:30:07 $
// $Locker:  $
//
// $Log:	XMScrolledW.hh,v $
Revision 1.4  89/12/08  15:30:07  grlcr
*** empty log message ***

Revision 1.3  89/11/22  13:03:34  kseethar
major reworking

Revision 1.2  89/11/03  09:39:53  grlcr
*** empty log message ***

Revision 1.1  89/11/02  12:38:09  motifplb
Initial revision

// ***** Created Oct 11, 1989 by BRM *****
//-----------------------------------------------------------------------------
*/

#ifndef XMScrolledW_hh
#define XMScrolledW_hh

#include "XMManager.hh"
#include <Xm/ScrolledW.h>


class XMScrolledWindow : public XMManager {
 protected:
     // ****CONSTRUCTORS****
     XMScrolledWindow ();

 public :
     // ****CONSTRUCTORS****
     XMScrolledWindow (XMObject* parent, String,Boolean managed=True);

     // ****DESTRUCTOR****
     ~XMScrolledWindow ();

     // ****METHODS TO SET THE ScrolledWindow RESOURCES****
     void set_horizontalScrollBar        (XMObject*);
     void set_scrollBarDisplayPolicy     (u_char);
     void set_scrollBarPlacement         (u_char);
     void set_scrolledWindowMarginHeight (Dimension);
     void set_scrolledWindowMarginWidth  (Dimension);
     void set_scrollingPolicy            (u_char);
     void set_spacing                    (Dimension);
     void set_verticalScrollBar          (XMObject*);
     void set_visualPolicy               (u_char);
     void set_workWindow                 (XMObject*);

     // ****METHODS TO GET THE ScrolledWindow RESOURCES****
     void get_clipWindow                 (XMObject*);
     void get_horizontalScrollBar        (XMObject*);
     void get_scrollBarDisplayPolicy     (u_char*);
     void get_scrollBarPlacement         (u_char*);
     void get_scrolledWindowMarginHeight (Dimension*);
     void get_scrolledWindowMarginWidth  (Dimension*);
     void get_scrollingPolicy            (u_char*);
     void get_spacing                    (Dimension*);
     void get_verticalScrollBar          (XMObject*);
     void get_visualPolicy               (u_char*);
     void get_workWindow                 (XMObject*);

     // ****TOOLKIT INTRINSIC COVER FUNCTIONS****
     void SetAreas (XMObject*, XMObject*, XMObject*);   
};

#endif     // XMScrolledWindow_hh

// dont add stuff after this endif
