/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
static char rcsid[] = "$Header: XMScrolledText.cc,v 1.1 89/12/05 16:18:32 kseethar Exp $";
/*
//-----------------------------------------------------------------------------
//
// $Source: /usr/proj/grl/motifplb/design_review_1_efforts/lib_1/XMScrolledText.cc,v $
// $Revision: 1.1 $
// $State: Exp $
// $Author: kseethar $
// $Date: 89/12/05 16:18:32 $
// $Locker:  $
//
// $Log:	XMScrolledText.cc,v $
Revision 1.1  89/12/05  16:18:32  kseethar
Initial revision


//-----------------------------------------------------------------------------
*/

#include "XMScrolledT.hh"
  
// ---------------------------------------------------------------------------
   XMScrolledText::XMScrolledText () : ()
// ---------------------------------------------------------------------------
{
}

// ---------------------------------------------------------------------------
   XMScrolledText::XMScrolledText (XMObject *parent, String name,
				   Boolean managed = True) : ()
// ---------------------------------------------------------------------------
{
  this->set_editMode (XmMULTI_LINE_EDIT);
  w = XmCreateScrolledText (parent->get_widget (), name, args, args_count);
  if (managed)
    this->Manage ();

  cb_associate( w, this );
}


// ---------------------------------------------------------------------------
 XMScrolledText::XMScrolledText (XMObject *parent, String name,
                                 Boolean scroll_vertical,
                                 Boolean scroll_horizontal,
                                 Boolean managed = True) : ()
// ---------------------------------------------------------------------------
{
  this->set_scrollVertical   (scroll_vertical);
  this->set_scrollHorizontal (scroll_horizontal);
  this->set_editMode (XmMULTI_LINE_EDIT);
 w  = XmCreateScrolledText (parent->get_widget (), name, args, args_count);
 if (managed)
    this->Manage ();
 cb_associate( w, this );
}


// ---------------------------------------------------------------------------
 XMScrolledText::XMScrolledText (XMObject *parent, String name, 
				 Boolean scroll_vertical,
				 Boolean scroll_horizontal,
				 Boolean scroll_leftSide,
				 Boolean scroll_topSide,
				 Boolean managed = True) : ()
// ---------------------------------------------------------------------------
{
  this->set_editMode (XmMULTI_LINE_EDIT);
  this->set_scrollVertical   (scroll_vertical);
  this->set_scrollHorizontal (scroll_horizontal);
  this->set_scrollLeftSide   (scroll_leftSide);
  this->set_scrollTopSide    (scroll_topSide);
 w  = XmCreateScrolledText (parent->get_widget (), name, args, args_count);
 if (managed)
    this->Manage ();
 cb_associate( w, this );
}

// ---------------------------------------------------------------------------
   XMScrolledText::~XMScrolledText ()
// ---------------------------------------------------------------------------
{
}

SET_BIND (XMScrolledText, set_scrollHorizontal, XmNscrollHorizontal, Boolean)
GET_BIND (XMScrolledText, get_scrollHorizontal, XmNscrollHorizontal, Boolean*)

SET_BIND (XMScrolledText, set_scrollLeftSide, XmNscrollLeftSide, Boolean)
GET_BIND (XMScrolledText, get_scrollLeftSide, XmNscrollLeftSide, Boolean*)

SET_BIND (XMScrolledText, set_scrollTopSide, XmNscrollTopSide, Boolean)
GET_BIND (XMScrolledText, get_scrollTopSide, XmNscrollTopSide, Boolean*)

SET_BIND (XMScrolledText, set_scrollVertical, XmNscrollVertical, Boolean)
GET_BIND (XMScrolledText, get_scrollVertical, XmNscrollVertical, Boolean*)
