/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */
/*
 *****************************************************************************
 *                                                                           *
 *  UNIVERSITY OF LOWELL Motif/C++ Binding				     *	
 *                                                                           *
 *  COPYRIGHT (c) 1990 BY  UNIVERSITY OF LOWELL, DEPARTMENT OF COMPUTER      *
 *  SCIENCE, LOWELL, MA 01854                                                *
 *                                                                           *
 *  LICENSED MATERIAL - PROGRAM PROPERTY OF UNIVERSITY OF LOWELL. ALL RIGHTS *
 *  RESERVED.                                                                *
 *                                                                           *
 *  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND COPIED    *
 *  ONLY  IN  ACCORDANCE  WITH  THE TERMS OF  SUCH  LICENSE  AND WITH THE    *
 *  INCLUSION OF THE  ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY OTHER    *
 *  COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY    *
 *  OTHER PERSON.  NO TITLE TO  OR OWNERSHIP OF  THE  SOFTWARE  IS HEREBY    *
 *  TRANSFERRED.                                                             *
 *                                                                           *
 *  THE INFORMATION IN THIS SOFTWARE IS  SUBJECT TO CHANGE WITHOUT NOTICE    *
 *  AND  SHOULD  NOT BE CONSTRUED AS A COMMITMENT BY UNIVERSITY OF LOWELL    *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * File Name      :                                                          *
 * Author         :                                                          *
 * Created        :                                                          *
 * Description    :                                                          *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 * Edit History   :                                                          *
 * date         who                     what                                 *
 *                                                                           *
 *****************************************************************************
 */

// ---------------------------------------------------------------------------
//
// File             : HelloForm.cc
// Description      : Demo program for C++ classes
// Revision History : Created Nov 9, 1989 by GRLCR
//
// ---------------------------------------------------------------------------

#include "XMAppShell.hh"                       // ApplicationShell class
#include "XMForm.hh"                           // Form class
#include "XMPushB.hh"                          // PushButtonGadget class

DECLARE_ENTRY (armCB);
DECLARE_ENTRY (disarmCB);
//void exit (int);

// ---------------------------------------------------------------------------
void main (unsigned int argc,  char **argv) {

  XMString             Hello  ("Hello World");
  XMApplicationShell   shell  ("main", &argc, argv);
  XMForm               form   (&shell, "form");
  XMPushButton         button  (&form, "Button 1");
  XMPushButton         button2 (&form, "Button 2");

  button.set_entry_armCallback    (armCB, NULL);
  button.set_entry_disarmCallback (disarmCB, NULL);

  form.set_leftAttachment   (&button, XmATTACH_FORM);
  form.set_rightAttachment  (&button, XmATTACH_FORM);
  form.set_topAttachment    (&button, XmATTACH_FORM);
//  form.set_topPosition      (&button, 30);
//  form.set_bottomAttachment (&button, XmATTACH_WIDGET);
//  form.set_bottomWidget     (&button, &button2);

  form.set_topAttachment    (&button2, XmATTACH_WIDGET);
  form.set_topWidget        (&button2, &button);
  form.set_leftAttachment   (&button2, XmATTACH_FORM);
  form.set_rightAttachment  (&button2, XmATTACH_FORM);
  form.set_bottomAttachment (&button2, XmATTACH_FORM);
//  form.set_bottomPosition   (&button2, 60);

  form.Manage ();
  button.Manage ();
  button2.Manage ();
  shell.Realize ();

  XtMainLoop ();
}
     
// ---------------------------------------------------------------------------
ENTRY (armCB, XMPushButton, button, c1, c2)

 XMString             Goodbye  ("Goodbye World");

 button->set_labelString (&Goodbye);
 button->set ();
}
    
// ---------------------------------------------------------------------------
ENTRY (disarmCB, XMPushButton, button, c1, c2)

 exit (0);
}
